<!DOCTYPE html>

<html lang="zh-cn">

<head>
    <script>
        (() => {
            var url = window.location.href;
            if (url.match(/^https/) === null && url.match(/^http:\/\/localhost/) === null) {
                window.location.href = url.replace('http', 'https');
            }
        })();
    </script>
    <title>FDD Cloud</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
</head>

<body>
    <div id="app">
        <h3>路径: {{ path }}</h3>
        <template v-if="itemList.length > 0">
            <p>文件夹数目: {{ dirnum }} 文件数目: {{ filenum }}</p>
            <ul>
                <li v-if="path !== '.'">
                    <router-link :to="'/' + path + '/' + '..'">../</router-link>
                </li>
                <li v-for="item in itemList">
                    <router-link v-if="item.type === 'dir'" :to="'/' + path + '/' + item.name">{{ item.name }}/
                    </router-link>
                    <a v-else :href="baseurl_data + '/' + path + '/' + item.name" target="_blank">{{ item.name }}</a>
                    <ul>
                        <li>{{ item.type === 'dir' ? '文件夹' : '文件' }}&emsp;{{ sizeUtil(item.size) }}&emsp;{{ timeUtil(item.time) }}
                        </li>
                    </ul>
                </li>
            </ul>
        </template>
        <div v-else>加载中……</div>
    </div>
    <script crossorigin="anonymous" integrity="sha384-OZmxTjkv7EQo5XDMPAmIkkvywVeXw59YyYh6zq8UKfkbor13jS+5p8qMTBSA1q+F"
        src="//lib.baomitu.com/vue/2.6.11/vue.min.js"></script>
    <script crossorigin="anonymous" integrity="sha384-CFKP4mu2aEZDylNmi3T4nvSVvMIjfqDkz2rfskdOAkPkAIocK+cqVh+rLVAnonK5"
        src="//lib.baomitu.com/vue-router/3.1.3/vue-router.min.js"></script>
    <script crossorigin="anonymous" integrity="sha384-3zW4Ss6nBzDaj/vvjP2Qwu5xaWAzOgTSccYj0DfBO/5tDzQksJa+tWrYMlYPM00u"
        src="//lib.baomitu.com/axios/0.19.2/axios.min.js"></script>
    <script>
        const router = new VueRouter({
            routes: [{ path: '/*' }]
        });
        new Vue({
            router,
            data: {
                baseurl: 'https://g.yussgrw.cn:82/fddcloud/api',
                baseurl_data: 'http://cloud.flwfdd.xyz/data',
                itemList: ['1', '2'],
                dirnum: 0,
                filenum: 0,
                path: '.'
            },
            methods: {
                query: async function (url, params) {
                    params = ((obj) => {
                        if (obj) {
                            var res = [];
                            for (key in obj) {
                                res.push(key + '=' + obj[key]);
                            }
                            return '?' + res.join('&');
                        } else {
                            return '';
                        }
                    })(params);
                    return axios.get(url + params);
                },
                loadItems: async function () {
                    this.itemList = [];
                    let result = await this.query(this.baseurl, {
                        cmd: 'list',
                        path: this.path,
                        lim: 65535
                    });
                    this.dirnum = result.data.dir_num;
                    this.filenum = result.data.file_num;
                    this.path = result.data.path;
                    this.itemList = result.data.data;
                },
                timeUtil: function (raw) {
                    return new Date(raw * 1000).toLocaleString();
                },
                sizeUtil: function (raw) {
                    if (raw === undefined) {
                        return '0';
                    }
                    const units = ['B', 'KB', 'MB', 'GB', 'TB', 'PB'];
                    let unit = 0;
                    while (raw > 1024) {
                        unit++;
                        raw /= 1024;
                    }
                    return raw.toFixed(3).toString() + units[unit];
                }
            },
            mounted: async function () {
                this.path = this.$route.params.pathMatch || '.';
                this.loadItems();
            },
            watch: {
                $route(to, from) {
                    this.path = to.params.pathMatch || '.';
                    this.loadItems();
                    console.log('targetPath=%s', to.params.pathMatch);
                }
            }
        }).$mount('#app');
    </script>
</body>

</html>